#include <iostream>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "NSF_Core.h"
#include "NSF_File.h"

using namespace std;

CNSFCore nsfCore;
CNSFFile nsfFile;
BYTE buf[0x1000+200];

int main(int argc, char ** argv) {

    if (argc != 2) {cout << "usage: " << argv[0] << " file.nsf\n"; return 1;}

	if(nsfFile.LoadFile(argv[1],1,0))	return -1;
	
	if(!nsfCore.Initialize())						return -1;

	if(!nsfCore.SetPlaybackOptions(44100,1))								return -1;
	if(!nsfCore.LoadNSF(&nsfFile))														return -1;

	//nsfCore.SetPlaybackSpeed(0);

	nsfCore.SetTrack(nsfFile.nInitialTrack);

    FILE * outfile = fopen("raw.out","wb");
    if (!outfile) {cout << "error opening raw.out\n"; return 1;}
    for (int i=0;i<0x100;i++) {
        int written;
    	written=nsfCore.GetSamples(buf,0x1000/4);
    	fwrite(buf,written,1,outfile);
    }
    fclose(outfile); outfile=NULL;

    return 0;
}
